<?php
{
    function CreateQuery($_GET, $alias, $checkstatusgroup, $checkwhere, $needs)
    {
        $query0 = "SELECT ";

        $statusgroups = 0;
        foreach ($checkstatusgroup as $element)
            if ($element==-1)
                $statusgroups++;

        if ($statusgroups>0)
        {
            foreach ($checkstatusgroup as $key => $element)
                if ($element==-1)
                    $query0 .= " (if(IsNull(" . $key . "), if(isnull(fStartTime), 'not done', if(isnull(fFailedTime),if(isnull(" . $needs[$key] . "),'not done',if(date_sub(Now(),interval 12 hour) < fStartTime,'running','crashed')),if(isnull(" . $needs[$key] . "),'not done','failed'))) ,if(" . $key . "='1970-01-01 00:00:00','dont do','done'))) as '" . $alias[$key] . "', ";
//                    $query0 .= " (if(IsNull(" . $key . "), 'not done' ,if(" . $key . "='1970-01-01 00:00:00','dont do','done'))) as '" . $key . "', ";

            $query0 .= " count(*) as 'Run#'";

        }
        else
        {
            $query0 .= "fRunNumber as 'Run#' ";

            foreach ($_GET as $key => $element)
                if ($_GET[$key]=="On")
                    if (empty($checkwhere[$key]) || $checkwhere[$key]==0)
                        $query0 .= ", " . $key . " as '" . $alias[$key] . "' ";
        }

        $query0 .= " FROM RunProcessStatus ";

        if (strpos($query0, " WHERE ")==FALSE)
            $query0 .= " WHERE ";
        else
            $query0 .= " AND ";

        $query0 .= StatusQuery("fCCFileAvail", $needs);
        $query0 .= StatusQuery("fCaCoFileAvail", $needs);
        $query0 .= StatusQuery("fCaCoFileFound", $needs);
        $query0 .= StatusQuery("fRawFileAvail", $needs);
        $query0 .= StatusQuery("fDataCheckDone", $needs);
        $query0 .= StatusQuery("fTimingCorrection", $needs);

        $query0 .= "fRunNumber BETWEEN " . $_GET["fRunMin"] . " AND " . $_GET["fRunMax"] . " ";

        if ($statusgroups>0)
        {
            $query0 .= " GROUP BY ";
            $num = $statusgroups;
            foreach ($checkstatusgroup as $key => $element)
                if ($element==-1)
                {
                    $query0 .= $alias[$key];
                    if ($num-->1)
                        $query0 .= ", ";
                }
        }

        if (!empty($_GET["fSortBy"]))
        {
            $query0 .= " ORDER BY " . substr($_GET["fSortBy"], 0, -1) . " ";
            if (substr($_GET["fSortBy"], -1)=="-")
                $query0 .= "DESC";
        }

        if (empty($_GET["fNumStart"]))
            $_GET["fNumStart"]=0;

        if (empty($_GET["fSendTxt"]))
            $query0 .= " LIMIT " . $_GET["fNumStart"] . ", " . $_GET["fNumResults"];

        return $query0;
    }

    function InitGet($_GET)
    {
        // Find out whether it is the first call to the php script
        $first = empty($_GET["fRunMin"]) && empty($_GET["fRunMax"]);

        if (empty($_GET["fNumResults"]))
            $_GET["fNumResults"]="20";

        if (empty($_GET["fDataCheckDone"]))
            $_GET["fDataCheckDone"]="Off";

        if (empty($_GET["fDataCheckDoneStatus"]))
            $_GET["fDataCheckDoneStatus"]="0";

        if (empty($_GET["fCCFileAvail"]))
            $_GET["fCCFileAvail"]=$first?"On":"";

        if (empty($_GET["fCCFileAvailStatus"]))
            $_GET["fCCFileAvailStatus"]="0";

        if (empty($_GET["fCaCoFileAvail"]))
            $_GET["fCaCoFileAvail"]=$first?"On":"";

        if (empty($_GET["fCaCoFileAvailStatus"]))
            $_GET["fCaCoFileAvailStatus"]="0";

        if (empty($_GET["fCaCoFileFound"]))
            $_GET["fCaCoFileFound"]="Off";

        if (empty($_GET["fCaCoFileFoundStatus"]))
            $_GET["fCaCoFileFoundStatus"]="0";

        if (empty($_GET["fRawFileAvail"]))
            $_GET["fRawFileAvail"]=$first?"On":"";

        if (empty($_GET["fRawFileAvailStatus"]))
            $_GET["fRawFileAvailStatus"]="0";

        if (empty($_GET["fTimingCorrection"]))
            $_GET["fTimingCorrection"]=$first?"On":"";

        if (empty($_GET["fTimingCorrectionStatus"]))
            $_GET["fTimingCorrectionStatus"]="0";

    }

    function PrintForm($_GET, $host, $user, $pw, $db)
    {
        printf("<center>\n");
        printf("<form action=\"statusrps.php\" METHOD=\"GET\">\n");
        printf(" <table>\n");
        printf("  <tr><td>\n");

        PrintStatusMenu("fCCFileAvail",      "CC File available");
        printf("  </td><td>\n");
        PrintStatusMenu("fCaCoFileAvail",    "Caco File available");
        printf("  </td><td>\n");
        PrintStatusMenu("fRawFileAvail",     "Rawfile available");

        printf("  </td></tr><tr><td>\n");

        PrintStatusMenu("fTimingCorrection", "Timing Correction");
        printf("  </td><td>\n");
        PrintStatusMenu("fCaCoFileFound",    "Caco File");
        printf("  </td><td>\n");
        PrintStatusMenu("fDataCheckDone",    "Datacheck");

        printf(" </td></tr></table>\n");
        printf(" <p>\n");

        if (empty($_GET["fRunMin"]))
            $min = GetMin("fRunNumber", "RunProcessStatus", $host, $user, $pw, $db);
        else
            $min = $_GET["fRunMin"];

        if (empty($_GET["fRunMax"]))
            $max = GetMax("fRunNumber", "RunProcessStatus", $host, $user, $pw, $db);
        else
            $max = $_GET["fRunMax"];


        printf("Runs&nbsp;from&nbsp;<input name=\"fRunMin\" type=\"text\" size=\"6\" maxlength=\"6\" value=\"%s\">\n", $min);
        printf("to&nbsp;<input name=\"fRunMax\" type=\"text\" size=\"6\" maxlength=\"6\" value=\"%s\">&nbsp;&nbsp;&nbsp;\n", $max);

        printf(" <P>\n");

        printf(" Results:\n");
        printf(" <select name=\"fNumResults\">\n");

        $numres = array("10", "20", "50", "100", "200", "500");
        foreach ($numres as $element)
        {
            if ($element==$_GET["fNumResults"])
                printf("<option value=\"%s\" selected>%3s</option>\n", $element, $element);
            else
                printf("<option value=\"%s\">%3s</option>\n", $element, $element);
        }
        printf(" </select>\n");
        printf(" &nbsp;&nbsp;&nbsp;\n");

        ini_set("mysql.trace_mode", "Off");
        ini_set("display_errors", "Off");

        printf("<input class='Width' type='submit' value='Query Table'>&nbsp;&nbsp;&nbsp;\n");
        printf("<input class='Width' type='button' value='Reset' onClick='self.location.href=\"statusrps.php\"'>&nbsp;&nbsp;&nbsp;\n");
        if (strchr($_SERVER["REQUEST_URI"], '?')!=FALSE)
            printf("<input class='Width' type='button' value='Get .txt' onClick='self.location.href=\"%s&fSendTxt=1\"'>&nbsp;&nbsp;&nbsp;\n", $_SERVER["REQUEST_URI"]);
        printf("</form>\n");
        printf("</center>\n");
        printf("</td>\n");
        printf("</tr>\n");
        printf("<tr class='Block'>\n");
        printf("<td>\n");
    }

    function PrintPage($html, $host, $user, $pw, $db, $alias, $rightalign, $checkstatusgroup, $checkwhere, $needs)
    {
        $db_id = mysql_connect($host, $user, $pw);
        if ($db_id==FALSE)
        {
            printf("mysql_connect returned the following error: %s\n", mysql_error());
            die("");
        }
        mysql_select_db($db);

        $query0 = CreateQuery($_GET, $alias, $checkstatusgroup, $checkwhere, $needs);

        $result0 = mysql_query($query0, $db_id);

        if ($result0)
        {
            if ($html=="1")
                PrintMagicTable($result0, $alias, $rightalign, "", "", $_GET);
            else
                PrintText($result0);

            mysql_free_result($result0);
        }
        mysql_close($db_id);

        PrintSubmittedQuery($query0, $html, $db, "old");
    }

    include ("include.php");
    include ("db.php");
    include ("magicdefs.php");

    ini_set("display_errors", "On");
    ini_set("mysql.trace_mode", "On");

    if (!empty($_GET["fSendTxt"]))
    {
        header("Content-type: application/octet");
        header("Content-Disposition: attachment; filename=query-result.txt");

        PrintPage("0", $host, $user, $pw, $db, $alias, $rightalign, $checkstatusgroup, $checkwhere, $needs);
    }
    else
    {
        echo (file_get_contents("index-header.html"));

        $environment = sizeof($_GET);

        InitGet($_GET);
        PrintForm($_GET, $host, $user, $pw, $db);

        if ($environment==0)
            printf("No query submitted yet.<BR>");
        else
            PrintPage("1", $host, $user, $pw, $db, $alias, $rightalign, $checkstatusgroup, $checkwhere, $needs);

        echo (file_get_contents("index-footer.html"));
    }

    ini_set("display_errors", "Off");
    ini_set("mysql.trace_mode", "Off");
}
?>
